#ifndef _3DMATH
#define _3DMATH
//=====================================================================
//
//	RcZ֌W
//		thanx! Zed 3d and Doomsday
//
//=====================================================================

#include <math.h>
#include "settings.h"

//          //
// Op֐ //
//          //
#define M_PI 3.14159265358979323846

#define SINTBL_ANGLE 1024
#define SINTBL_MUL   (SINTBL_ANGLE / (M_PI * 2) )
#define SINTBL_MASK  (SINTBL_ANGLE - 1)
#define SINTBL_COS   (SINTBL_ANGLE / 4)

// TCRTC֐ݒ //
#define SinTBL(r) ( m_fSinTable [   (int)( (r) * SINTBL_MUL ) & SINTBL_MASK                ] )
#define CosTBL(r) ( m_fSinTable [ ( (int)( (r) * SINTBL_MUL ) & SINTBL_MASK ) + SINTBL_COS ] )

//=========================================================================
//
//	w\
//
//========================================================================

// RxNg //
typedef struct{
	union {
		float fR;
		float fX;
	};
	union {
		float fG;
		float fY;
	};
	union {
		float fB;
		float fZ;
	};
}VECTOR3;

typedef const VECTOR3 C_VECTOR3;//const`錾

// Op|S //
typedef struct{
	int iVIndex[3];//_ւ̃CfbNX
}PORY3;

typedef const PORY3 C_PORY3;//const`錾


// RR}gNX //
typedef struct{
	float f11, f12, f13;
	float f21, f22, f23;
	float f31, f32, f33;
}MATRIX33;

typedef const MATRIX33 C_MATRIX33;//const`錾

//=========================================================================
//
//	RcZNX
//
//========================================================================
class C3dmath
{
	public:
		C3dmath();
		//==========RTCTCe[u\z
		void InitSinTable();

		// xNgZbg //
		inline void VectorSet( VECTOR3 &dest, float fX, float fY, float fZ )
		{
			dest.fX = fX;
			dest.fY = fY;
			dest.fZ = fZ;
		}

		// xNgZ //
		inline void VectorAdd( VECTOR3 &dest, C_VECTOR3 &op1, C_VECTOR3 &op2 )
		{
			dest.fX = op1.fX + op2.fX;
			dest.fY = op1.fY + op2.fY;
			dest.fZ = op1.fZ + op2.fZ;
		}

		// xNgZ //
		inline void VectorSub( VECTOR3 &dest, C_VECTOR3 &op1, C_VECTOR3 &op2 )
		{
			dest.fX = op1.fX - op2.fX;
			dest.fY = op1.fY - op2.fY;
			dest.fZ = op1.fZ - op2.fZ;
		}

		// xNg̃XJ //
		inline void VectorMul( VECTOR3 &dest, C_VECTOR3 &op1, float fMul )
		{
			dest.fX = op1.fX * fMul;
			dest.fY = op1.fY * fMul;
			dest.fZ = op1.fZ * fMul;
		}

		// xNg̃XJZ //
		inline void VectorDiv( VECTOR3 &dest, C_VECTOR3 &op1, float fDiv )
		{
			//===========ȍiZ|Zj
			float fI = 1.0f / fDiv;

			dest.fX = op1.fX * fI;
			dest.fY = op1.fY * fI;
			dest.fZ = op1.fZ * fI;
		}

		// xNgO //
		inline void VectorCross( VECTOR3 &dest, C_VECTOR3 &op1, C_VECTOR3 &op2 )
		{
			dest.fX = op1.fY * op2.fZ - op1.fZ * op2.fY;
			dest.fY = op1.fZ * op2.fX - op1.fX * op2.fZ;
			dest.fZ = op1.fX * op2.fY - op1.fY * op2.fX;
		}

		// xNg //
		inline float VectorDot( C_VECTOR3 &op1, C_VECTOR3 &op2 )
		{
			return op1.fX * op2.fX + op1.fY * op2.fY + op1.fZ * op2.fZ;
		}

		// xNg̐K //
		inline void VectorNormalize( VECTOR3 &pvec )
		{
			float l = (float) sqrt(pvec.fX * pvec.fX + pvec.fY * pvec.fY + pvec.fZ * pvec.fZ);
			pvec.fX /= l;
			pvec.fY /= l;
			pvec.fZ /= l;
		}

		// xNg~}gNX //
		inline void Multiply( VECTOR3* dest, C_VECTOR3& op1, C_MATRIX33& op2 )
		{
			dest->fX = op1.fX * op2.f11 + op1.fY * op2.f21 + op1.fZ * op2.f31;
			dest->fY = op1.fX * op2.f12 + op1.fY * op2.f22 + op1.fZ * op2.f32;
			dest->fZ = op1.fX * op2.f13 + op1.fY * op2.f23 + op1.fZ * op2.f33;
		}

		// }gNX~}gNX //
		inline void Multiply( MATRIX33* dest, C_MATRIX33& op1, C_MATRIX33& op2 )
		{
			dest->f11 = op1.f11 * op2.f11 + op1.f12 * op2.f21 + op1.f13 * op2.f31;
			dest->f12 = op1.f11 * op2.f12 + op1.f12 * op2.f22 + op1.f13 * op2.f32;
			dest->f13 = op1.f11 * op2.f13 + op1.f12 * op2.f23 + op1.f13 * op2.f33;

			dest->f21 = op1.f21 * op2.f11 + op1.f22 * op2.f21 + op1.f23 * op2.f31;
			dest->f22 = op1.f21 * op2.f12 + op1.f22 * op2.f22 + op1.f23 * op2.f32;
			dest->f23 = op1.f21 * op2.f13 + op1.f22 * op2.f23 + op1.f23 * op2.f33;

			dest->f31 = op1.f31 * op2.f11 + op1.f32 * op2.f21 + op1.f33 * op2.f31;
			dest->f32 = op1.f31 * op2.f12 + op1.f32 * op2.f22 + op1.f33 * op2.f32;
			dest->f33 = op1.f31 * op2.f13 + op1.f32 * op2.f23 + op1.f33 * op2.f33;
		}

		// ]s̍쐬 //
		inline void MakeRotateMatrix( MATRIX33* mtrx, float fH, float fP, float fB )
		{
			float sbsh = SinTBL(fB) * SinTBL(fH);
			float cbsh = CosTBL(fB) * SinTBL(fH);
			float sbch = SinTBL(fB) * CosTBL(fH);
			float cbch = CosTBL(fB) * CosTBL(fH);

			mtrx->f11 =  cbch + sbsh*SinTBL(fP);
			mtrx->f21 = -sbch + cbsh*SinTBL(fP);
			mtrx->f31 =  CosTBL(fP)*SinTBL(fH);

			mtrx->f12 =  SinTBL(fB)*CosTBL(fP);
			mtrx->f22 =  CosTBL(fB)*CosTBL(fP);
			mtrx->f32 = -SinTBL(fP);

			mtrx->f13 = -cbsh + sbch*SinTBL(fP);
			mtrx->f23 =  sbsh + cbch*SinTBL(fP);
			mtrx->f33 =  CosTBL(fP)*CosTBL(fH);
		}

		inline void MakeRotateMatrix( MATRIX33* mtrx, C_VECTOR3& vec)
		{
			MakeRotateMatrix(mtrx, vec.fX,vec.fY, vec.fZ);
		}

		// Elւ //
		template<class T>
		void Swap(T &a, T &b)
		{
			b = a - b;
			a -= b;
			b += a;
		}

		// 16bitJ[Zbg //
		inline short int SetColor16(int ir, int ig,int ib)
		{
			short int sColor;

			ir >>= 3;
			ig >>= 3;
			ib >>= 3;

			sColor = (ir<<10) + (ig<<5) + ib;

			return sColor;
		}

		// }WbNR[hAfloat̒gIEEE`Ȃ̂Ƃ
		// |C^nŃSS܂B
		#define BIG_NUM     (double(1 << 26) * (1 << 26) * 1.5)
		inline int FloatToInt(float x)
		{
			double temp = x + BIG_NUM;

			return *(int*)&temp;
		}

	private:
		//==========RTCTCe[u
		float m_fSinTable[SINTBL_ANGLE + SINTBL_COS];

};

#endif //_3Dmath
