#include "gdi.h"
#include "misc.h"
///////////////////////////////////////////////
/////OtBbNfBoCXReLXgNX
///////////////////////////////////////////////
CGdi :: CGdi()
{
	m_OnScreen = NULL;
	m_OffScreenCount = 0;
	m_FullScreen = FALSE;

	for(int i=0 ; i < OFFSCREENMAX ; i++)
	{
		m_OffScreen[i] = NULL;
		m_Pbits[i] = NULL;
	}

}
CGdi :: ~CGdi()
{
	if(m_FullScreen) ChangeWindowMode();

	for(int i = 0 ; i < OFFSCREENMAX ; i++)
	{
		if(!m_OffScreen[i])continue;
		DeleteObject(SelectObject(m_OffScreen[i], m_OldBitmap[i]));
		DeleteDC(m_OffScreen[i]);
	}
	//ʂcbJ
	if(m_OnScreen)ReleaseDC(m_OnScreenMakedHandle, m_OnScreen);

}
BOOL CGdi :: CreateOnScreen(HWND hwnd)
{
	//ĂǂȁH
	//S̓_ł͊댯Ǝv񂾂
	//C̋K񂪕ςAAΏłȂˁA
	if(m_OnScreen) return FALSE;

	m_OnScreen = GetDC(hwnd);
	m_OnScreenMakedHandle = hwnd;

	return TRUE;
}

//܂߂ȂlɁAHDCă\HB
//ԂƂȂłЂ܂邩DD
BOOL CGdi :: CreateOffScreen(int wx, int wy, int num, int Mode)
{
	if(m_OffScreen[num])return FALSE;
	if(num >= OFFSCREENMAX || num < 0)return FALSE;

	m_OffScreen[num] = CreateCompatibleDC(m_OnScreen);

	BITMAPINFO info;

	//\̏
	info.bmiHeader.biSize = sizeof( BITMAPINFOHEADER );
	info.bmiHeader.biWidth = wx;
	info.bmiHeader.biHeight = -wy;
	info.bmiHeader.biPlanes = 1;
	info.bmiHeader.biBitCount = Mode;
	info.bmiHeader.biCompression = BI_RGB;
	info.bmiHeader.biSizeImage = wx*wy*(Mode/8);
	info.bmiHeader.biXPelsPerMeter = 0;
	info.bmiHeader.biYPelsPerMeter = 0;
	info.bmiHeader.biClrUsed = 0;
	info.bmiHeader.biClrImportant = 0;

	m_OldBitmap[num] = SelectObject(m_OffScreen[num],
		CreateDIBSection(m_OnScreen, &info, DIB_RGB_COLORS, 
			(void **)&m_Pbits[num], NULL, 0));

	PatBlt(m_OffScreen[num] ,0, 0, wx, wy, BLACKNESS);

	m_OffScreenWidth[num]  = wx;
	m_OffScreenHeight[num] = wy;

	m_OffScreenCount++;

return TRUE;
}
BOOL CGdi :: DeleteOffScreen(int num)
{
	if(num >= OFFSCREENMAX || num < 0)return FALSE;
	if(!m_OffScreen[num])return FALSE;

	int i = num;

		m_OffScreen[i] = NULL;
		m_Pbits[i] = NULL;
		DeleteObject(SelectObject(m_OffScreen[i], m_OldBitmap[i]));
		DeleteDC(m_OffScreen[i]);
		m_OffScreenCount--;

return TRUE;
}

//////////////////////////////////////////
//Getn

HDC CGdi :: GetOnScreen(void)
{
	if(!m_OnScreen)return FALSE;
	return m_OnScreen;
}
HDC CGdi :: GetOffScreen(int num)
{
	if(!m_OffScreen[num])return FALSE;

	return m_OffScreen[num];

}
BYTE* CGdi :: GetPbits(int num)
{
	if(!m_Pbits[num])return FALSE;
	return m_Pbits[num];

}

///////////////////////////////////////////////
//XN[\֌W
BOOL CGdi :: OnScreenShow(int num)
{
	if(!m_OnScreen)return FALSE;
	if(!m_OffScreen[num])return FALSE;

		BitBlt(m_OnScreen,
			0,0,
			m_OffScreenWidth[num], m_OffScreenHeight[num],
			m_OffScreen[num],
			0,0,
			SRCCOPY);

return TRUE;
}
//tXN[Ƃ640*480̎łiRR
//̂Direct-X炻̃tXN[g悤ɍ׍H
void CGdi :: ChangeFullScreen(void)
{
	if(m_FullScreen) return;

	DEVMODE DevMode;

	DevMode.dmPelsWidth = 320;
	DevMode.dmPelsHeight = 240;
	DevMode.dmSize = sizeof(DEVMODE);
	DevMode.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT;
	ChangeDisplaySettings(&DevMode, 0);

	m_FullScreen = TRUE;
}
void CGdi :: ChangeWindowMode(void)
{
	if(!m_FullScreen) return;

	ChangeDisplaySettings(NULL, 0);
	m_FullScreen = FALSE;

}
BOOL CGdi :: GetScreenMode(void)
{

return m_FullScreen;
}

//n
//`񂺂ԂƂƈԊԈႦ邩
BOOL CGdi :: Copy(int dest, int destx, int desty, int source)
{
	if(!m_OffScreen[source])return FALSE;
	if(!m_OffScreen[dest])return FALSE;

	BitBlt(
		m_OffScreen[dest],
		destx,
		desty,
		m_OffScreenWidth[source],
		m_OffScreenHeight[source],
		m_OffScreen[source],
		0,
		0,
		SRCCOPY
	);
return TRUE;
}
//ubg]
BOOL CGdi:: RevBlt(int num, int x, int y, int dx, int dy)
{
	if(!m_OffScreen[num])return FALSE;
	if(!m_OnScreen)return FALSE;

	BitBlt(m_OnScreen, x, y, dx, dy, m_OffScreen[num],x, y, NOTSRCCOPY);
return TRUE;
}
