#include "dialog.h"
#include "misc.h"
//=====================================================================
//
//	_CAONX
//
//=====================================================================

CDialog :: CDialog()
{
	m_GridSizeStr = NULL;
	m_CloseFlag   = FALSE;
	m_CloseButton = FALSE;
}
CDialog :: ~CDialog()
{

}
BOOL CDialog :: CreateShow(HWND hwnd, LPSTR DefStrings, LPSTR DefPath )
{
	m_GridSizeStr = DefStrings;
	m_FilePath    = DefPath;

	CreateDialogParam( CMain :: hInstance,
					MAKEINTRESOURCE(IDD_DIALOG1),
					hwnd,
					(DLGPROC)DlgProc,
					(LPARAM)this
				);

return TRUE;
}

LRESULT CALLBACK CDialog :: DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static CDialog *Imput;

	switch (msg)
	{
		case WM_INITDIALOG:
			Imput = (CDialog*)lParam;

			SetDlgItemText(hwnd, IDC_EDIT1, Imput->m_GridSizeStr);
			SetDlgItemText(hwnd, IDC_EDIT3, Imput->m_FilePath);
		break;

		HANDLE_MSG(hwnd, WM_COMMAND, Imput->OnCommand);break;
		HANDLE_MSG(hwnd, WM_DESTROY, Imput->OnDestroy);break;
		HANDLE_MSG(hwnd, WM_CLOSE  , Imput->OnClose);break;

		default:
			return FALSE;
	}

	return TRUE;
}

void CDialog :: OnCommand(HWND Hwnd, int id, HWND hwndctl, UINT code)
{
	switch( id )
	{
		case IDOK:
			GetDlgItemText(Hwnd, IDC_EDIT1, m_GridSizeStr, 20);
			m_CloseFlag = TRUE;
			DestroyWindow(Hwnd);
		break;
		case IDC_BUTTON1:
			GetFilePath(Hwnd, m_FilePath);
			SetDlgItemText(Hwnd, IDC_EDIT3, m_FilePath);
		break;
	}
}
void CDialog :: OnDestroy (HWND Hwnd)
{
	m_CloseFlag = TRUE;
}
void CDialog :: OnClose (HWND Hwnd)
{
	m_CloseButton = TRUE;
	DestroyWindow(Hwnd);
}
int CDialog :: GetGridSize()
{
	return ( atoi(m_GridSizeStr) );
}
BOOL CDialog :: GetFilePath(HWND Hwnd, LPSTR FilePath)
{
	OPENFILENAME file;

	memset( &file, 0, sizeof(OPENFILENAME));

	file.lStructSize = sizeof(OPENFILENAME);
	file.hwndOwner   = Hwnd;
	file.lpstrFilter = "avi file {*.avi}\0*.avi\0";
	file.lpstrFile   = FilePath;
	file.nMaxFile    = MAX_PATH;
	file.Flags       = OFN_FILEMUSTEXIST;
	file.lpstrDefExt = "avi";

	if( GetOpenFileName(&file) ) return TRUE;

return FALSE;
}
