#include "video.h"
#include "misc.h"
//////////////////////////////////////////////////////
//`uhNXA
/////////////////////////////////////////////////////
CVideo :: CVideo(HWND hwnd, LPSTR PlogName, BOOL *clfg, BOOL *flfg)
{
	m_VloopFlag = FALSE;
	m_VDeviceID = NULL;
	m_VPlayFlag = FALSE;
	m_VPauseFlag = FALSE;
	m_FoundAVI = TRUE;

	m_Hwnd = hwnd;
}
CVideo::~CVideo()
{

	if(m_VDeviceID) mciSendCommand(m_VDeviceID, MCI_CLOSE , MCI_WAIT, NULL);

}
BOOL CVideo :: Vopen(LPSTR filename, BOOL LoopFlag)
{
	int i;
	DWORD dwReturn;

	MCI_OVLY_OPEN_PARMS mciOpenParams;

	//-JgpXς̑Ώ
	//GetPath();
	//filename = strcat(Path, filename);
	//-

	mciOpenParams.lpstrDeviceType = "AVIVideo";
	mciOpenParams.lpstrElementName = filename;
	mciOpenParams.dwStyle = WS_CHILD;
	mciOpenParams.hWndParent = m_Hwnd;
	m_VloopFlag = LoopFlag;

	for(i=0 ; i<5 ; i++)
	{
		if(!(dwReturn = mciSendCommand(NULL,MCI_OPEN,
									MCI_OPEN_TYPE | MCI_OPEN_ELEMENT | MCI_WAIT |
									MCI_DGV_OPEN_PARENT | MCI_DGV_OPEN_WS,
									(DWORD)(LPVOID)&mciOpenParams)))
		{
		break;
		}
		//else

		Sleep(250);
	}
	if(i >= 5)return FALSE;

	m_VDeviceID = (UINT)mciOpenParams.wDeviceID;

return TRUE;
}
BOOL CVideo :: Vplay(LPSTR filename, BOOL LoopFlag, RECT rect)
{
	DWORD dwReturn=FALSE;
	MCI_PLAY_PARMS mciPlayParams;
	MCI_DGV_PUT_PARMS mciDgvPutParams;

	if(m_FoundAVI)
	{

		Vclose();

		if( !Vopen(filename, LoopFlag) )
		{
			ShowMCIError (m_Hwnd, dwReturn ,"`uhmۂŃG[o܂");
			m_FoundAVI = FALSE;
			m_VPlayFlag = FALSE;
			return FALSE;
		}

		mciDgvPutParams.rc.top    = rect.top;
		mciDgvPutParams.rc.left   = rect.left;
		mciDgvPutParams.rc.right  = rect.right;
		mciDgvPutParams.rc.bottom = rect.bottom;

		if(dwReturn = mciSendCommand(m_VDeviceID, MCI_PUT, MCI_WAIT |
							 MCI_DGV_RECT | MCI_DGV_PUT_WINDOW | MCI_DGV_PUT_CLIENT,
									(DWORD)(LPVOID)&mciDgvPutParams))
		{
			ShowMCIError(m_Hwnd, dwReturn, "`uh͈͐ݒŃG[o܂");
			m_VPlayFlag = FALSE;
			mciSendCommand(m_VDeviceID, MCI_CLOSE, MCI_WAIT, NULL);
			return FALSE;
		}

		mciPlayParams.dwCallback =  (DWORD)m_Hwnd;

		dwReturn = mciSendCommand(m_VDeviceID,
								MCI_PLAY,
								MCI_NOTIFY,
								(DWORD)(LPVOID)&mciPlayParams);
		if(dwReturn)
		{
			ShowMCIError(m_Hwnd, dwReturn, "`uhtŃG[o܂");
			m_VPlayFlag = FALSE;
			mciSendCommand(m_VDeviceID, MCI_CLOSE, MCI_WAIT, NULL);
			return FALSE;
		}
		m_VPlayFlag = TRUE;
	}

	return TRUE;
}

void CVideo :: ShowMCIError(HWND parent, DWORD error, LPSTR code)
{
	char buf[255];

	mciGetErrorString(error, buf, sizeof(buf));
	MessageBox(parent, buf, code, MB_OK | MB_ICONEXCLAMATION);

}
void CVideo::OnMCINotify (HWND Hwnd, UINT deviceID, UINT message)
{
	DWORD retval;
	MCI_PLAY_PARMS mciPlayParms;
	mciPlayParms.dwCallback = (DWORD)Hwnd;
	mciPlayParms.dwFrom = 0;

	if(deviceID == m_VDeviceID && m_VPlayFlag)
	{
		switch (m_VloopFlag)
		{
			case TRUE:
				if (retval = mciSendCommand (m_VDeviceID, MCI_PLAY,
					MCI_NOTIFY | MCI_FROM, (DWORD)(LPVOID)&mciPlayParms))
				{
						ShowMCIError (Hwnd, retval, "`uhĉtŃG[o܂");
				}
			break;

			case FALSE:
				Vclose();
			break;
		}
	}
}
BOOL CVideo :: Vclose()
{
	DWORD retval;

	if(m_VDeviceID && m_FoundAVI)
	{
		retval = mciSendCommand(m_VDeviceID, MCI_CLOSE , MCI_WAIT, NULL);
		if(retval) ShowMCIError (m_Hwnd, retval, "`uhJŃG[o܂");

		m_VDeviceID = NULL;
		m_VPlayFlag = FALSE;
	}
	return TRUE;
}
BOOL CVideo :: SetTimeFormat()
{
	// ԃtH[}bgw 
	MCI_SET_PARMS mciSet; 
	DWORD result = mciSendCommand(m_VDeviceID, MCI_SET_TIME_FORMAT, MCI_FORMAT_FRAMES |
									MCI_WAIT, (DWORD)&mciSet); 

	if(!result) return FALSE; 

	return TRUE;
}
BOOL CVideo :: SteptoDC(HDC destDC, int step)
{
	if(!m_VDeviceID) return FALSE;

	// XebvĐ 
	MCI_SEEK_PARMS mciSeek; 
	mciSeek.dwCallback = (DWORD)m_Hwnd; 
	mciSeek.dwTo = step;

	DWORD result = mciSendCommand(m_VDeviceID, MCI_SEEK, MCI_TO | MCI_WAIT, (DWORD)&mciSeek);

	if(result != 0) return FALSE;

	// DUMP 
	MCI_ANIM_UPDATE_PARMS mciUpdate; 
	mciUpdate.dwCallback = (DWORD)m_Hwnd; 
	mciUpdate.hDC        = destDC; 
	mciUpdate.rc.left    = 0; 
	mciUpdate.rc.top     = 0; 
	mciUpdate.rc.bottom  = 240; 
	mciUpdate.rc.right   = 320; 

	result = mciSendCommand(m_VDeviceID, MCI_UPDATE, MCI_ANIM_UPDATE_HDC, 
							(DWORD)&mciUpdate);

return TRUE;
}
int CVideo :: GetMaxStep()
{
	if(!m_VDeviceID) return FALSE;

	MCI_STATUS_PARMS mciStatus;
	mciStatus.dwCallback = (DWORD)m_Hwnd; 
	mciStatus.dwItem = MCI_STATUS_LENGTH;
	DWORD result = mciSendCommand(m_VDeviceID, MCI_STATUS, MCI_STATUS_ITEM | MCI_WAIT,
									(DWORD)&mciStatus);

	if(result != 0) return FALSE;

return mciStatus.dwReturn;
}



void CVideo :: GetPath()
{
	int pt;

	GetModuleFileName(NULL, m_Path, MAX_PATH);
	pt = strlen(m_Path);

	while(m_Path[pt] != '\\')
	{
		pt--;
		if(pt < 0) return;
	}
	m_Path[pt+1] = 0;
}
